package com.mortals.xhx.common.excel.core;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.List;
import java.util.Map;

/**
 * @描述
 * @创建人 zxfei
 * @创建时间 2021/3/4
 * @修改人和其它信息
 */
public interface IExcelUtil<T> {
	
	/**
	 * 
	* 构建一个导入导出工具
	* @param clazz 一个类类型
	* @return  IExcelUtil<T> 返回类型 
	 */
	IExcelUtil<T> build(Class<T> clazz);
	
	/**
	 * 
	* 数据导出
	* @param sheetName
	* @param input
	* @return  List<T> 导出数据
	 */
	List<T> importExcel(String sheetName,String fileName, InputStream input);
	
	/**
	 * 
	* 导出到一个 sheet中
	* @param list
	* @param sheetName
	* @param output
	* @return  boolean   
	 */
	boolean exportExcel(List<T> list, String sheetName, OutputStream output, Map<String, String> configFieldMap);
	
	/**
	 * 
	* 导出到多个 sheet中
	* @param lists
	* @param sheetNames
	* @param output
	* @return  boolean 
	 */
	boolean exportExcel(List<T> lists[], String sheetNames[], OutputStream output,Map<String, String> configFieldMap);




	/**
	 *
	 * 导出到一个 sheet中
	 * @param list
	 * @param sheetName
	 * @param output
	 * @return  boolean
	 */
	boolean exportExcelFlat(List<T> list, String sheetName, OutputStream output, Map<String, String> configFieldMap);

	/**
	 *
	 * 导出到多个 sheet中
	 * @param lists
	 * @param sheetNames
	 * @param output
	 * @return  boolean
	 */
	boolean exportExcelFlat(List<T> lists[], String sheetNames[], OutputStream output,Map<String, String> configFieldMap);

}
